#include <ArduinoBLE.h>

#define SERVICE_UUID "180A"
#define CHARACTERISTIC_UUID "2A57"

// BLE LED Service
BLEService ledService(SERVICE_UUID);

// BLE LED Switch Characteristic
BLEUnsignedShortCharacteristic switchCharacteristic(CHARACTERISTIC_UUID, BLERead | BLEWriteWithoutResponse);

void setup()
{
               //Serial.begin(9600);
               Serial.begin(115200);
               while (!Serial);

               // set LED pin to output mode
               pinMode(LED_BUILTIN, OUTPUT);
               pinMode(5, OUTPUT);
               pinMode(6, OUTPUT);
               pinMode(7, OUTPUT);
               pinMode(8, OUTPUT);
               pinMode(9, OUTPUT);
               pinMode(10, OUTPUT);

               digitalWrite(LED_BUILTIN, LOW);  // turn LED_BUILTIN on (when the central disconnects, turn off the LED)
               digitalWrite(5, HIGH);           // turn LED1 off
               digitalWrite(6, HIGH);           // turn LED2 off
               digitalWrite(7, HIGH);           // turn LED3 off
               digitalWrite(8, HIGH);           // turn LED4 off
               digitalWrite(9, HIGH);           // turn LED5 off
               digitalWrite(10, HIGH);           // turn LED6 off

               // begin initialization
               if (!BLE.begin()) {
                 Serial.println("starting BLE device failed!");

                 while (1);
               }

               // set advertised local name and service UUID:
               BLE.setLocalName("Nano_33_BLE");
               BLE.setAdvertisedService(ledService);

               // add the characteristic to the service
               ledService.addCharacteristic(switchCharacteristic);

               // add service
               BLE.addService(ledService);

               // set the initial value for the characeristic:
               switchCharacteristic.writeValue(0);

               // start advertising
               BLE.advertise();

               Serial.println("BLE device Nano_33 active, waiting for connection");
}

void loop()
{
  // listen for BLE peripherals to connect:
  BLEDevice central = BLE.central();

               // if a central is connected to peripheral:
               if (central)
               {
                         Serial.print("Connected to central: ");
                         // print the central's MAC address:
                         Serial.println(central.address());
                          digitalWrite(LED_BUILTIN, HIGH);            // turn on the LED to indicate the connection

                         // while the central is still connected to peripheral:
                         while (central.connected())
                         {
                                   // if the remote device wrote to the characteristic,
                                   // use the value to control the LED:

                                   // Additional test 
                                   Serial.print("Value Received: ");
                                   Serial.println(switchCharacteristic.value());
                                   
                                   if (switchCharacteristic.written())
                                   {
                                             Serial.print("Value Received: ");
                                             Serial.println(switchCharacteristic.value()); //Check that the value received is valid

                                             switch (switchCharacteristic.value())
                                             {
                                               case 1:
                                                 Serial.println("green"); //green on
                                                 digitalWrite(5, LOW); //green on
                                                 digitalWrite(6, HIGH); //red off
                                                 digitalWrite(7, HIGH); //yellow off
                                                 digitalWrite(8, HIGH); //blue off
                                                 digitalWrite(9, HIGH); //purple off
                                                 digitalWrite(10, HIGH); //white off
                                            
                                                 break;
                                               case 2:
                                                 Serial.println("red"); //red on
                                                 digitalWrite(5, HIGH); //green off
                                                 digitalWrite(6, LOW); //red on
                                                 digitalWrite(7, HIGH); //yellow off
                                                 digitalWrite(8, HIGH); //blue off
                                                 digitalWrite(9, HIGH); //purple off
                                                 digitalWrite(10, HIGH); //white off
                                            
                                                 break;
                                               case 3:
                                                 Serial.println("yellow"); //yellow on
                                                 digitalWrite(5, HIGH); //green off
                                                 digitalWrite(6, HIGH); //red off
                                                 digitalWrite(7, LOW); //yellow on
                                                 digitalWrite(8, HIGH); //blue off
                                                 digitalWrite(9, HIGH); //purple off
                                                 digitalWrite(10, HIGH); //white off
                                                 break;
                                               case 4:
                                                 Serial.println("blue"); //blue on
                                                 digitalWrite(5, HIGH); //green off
                                                 digitalWrite(6, HIGH); //red off
                                                 digitalWrite(7, HIGH); //yellow off
                                                 digitalWrite(8, LOW); //blue on
                                                 digitalWrite(9, HIGH); //purple off
                                                 digitalWrite(10, HIGH); //white off
                                                 break;
                                               case 5:
                                                 Serial.println("purple");// purple on
                                                 digitalWrite(5, HIGH); //green off
                                                 digitalWrite(6, HIGH); //red off
                                                 digitalWrite(7, HIGH); //yellow off
                                                 digitalWrite(8, HIGH); //blue off
                                                 digitalWrite(9, LOW); //purple on
                                                 digitalWrite(10, HIGH); //white off
                                                 break;
                                                  case 6:
                                                 Serial.println("white");// white on
                                                 digitalWrite(5, HIGH); //green off
                                                 digitalWrite(6, HIGH); //red off
                                                 digitalWrite(7, HIGH); //yellow off
                                                 digitalWrite(8, HIGH); //blue off
                                                 digitalWrite(9, HIGH); //purple off
                                                 digitalWrite(10, LOW); //white on
                                                 break;
                                               case 7:
                                                 Serial.println("off");
                                                 digitalWrite(5, HIGH);
                                                 digitalWrite(6, HIGH);
                                                 digitalWrite(7, HIGH);
                                                 digitalWrite(8, HIGH);
                                                 digitalWrite(9, HIGH);
                                                 digitalWrite(10, HIGH);
                                                 break;
                                             }
                                   }
                         }

                         // when the central disconnects, print it out:
                         Serial.print("Disconnected from central: ");
                         Serial.println(central.address());
                         digitalWrite(LED_BUILTIN, HIGH);  // when the central disconnects, turn off the LED
                         digitalWrite(5, HIGH);
                         digitalWrite(6, HIGH);
                         digitalWrite(7, HIGH);
                         digitalWrite(8, HIGH);
                         digitalWrite(9, HIGH);
                         digitalWrite(10, HIGH);
               }
}
